<template>
    <div class="px-2">

        <h2>Withdraw Requests</h2>

        <table class="table table-hover" style="width: 99%">
            <thead>
            <tr>
                <th scope="col">#</th>
                <th scope="col">Publisher</th>
                <th scope="col">Amount</th>
                <th scope="col">Status</th>
            </tr>
            </thead>
            <tbody>
            <tr v-if="!tableLoading" v-for="withdrawRequest in withdrawRequests">
                <th scope="row">{{ withdrawRequest.id }}</th>
                <td>{{ withdrawRequest.publisher.user.name }}</td>
                <td>Br {{ withdrawRequest.amount }}</td>
                <td><a href="#" v-on:click.prevent="processWithdrawRequest(withdrawRequest.id, 'accept')">Accept</a> | <a href="#" v-on:click.prevent="processWithdrawRequest(withdrawRequest.id, 'reject')">Reject</a></td>
            </tr>
            </tbody>
        </table>

        <div class="text-center m-5 p-5" v-if="tableLoading">
            <span class="h2"><i class="fas fa-spinner fa-spin"></i></span>
        </div>

        <div class="alert alert-success" v-if="success">
            {{ success.message }}
            <button type="button" class="close" v-on:click.prevent="success = '';" aria-label="Close">
                <span aria-hidden="true">&times;</span>
            </button>
        </div>

        <div class="alert alert-danger" v-if="fail">
            {{ fail.message }}
            <button type="button" class="close" v-on:click.prevent="fail = '';" aria-label="Close">
                <span aria-hidden="true">&times;</span>
            </button>
        </div>


    </div>
</template>

<script>
    export default {
        data: function () {
            return {
                // Pending Withdraw Requests
                withdrawRequests: null,

                // Table Loading flag
                tableLoading: false,

                // Loading flag
                loading: false,

                // Status flags
                success: false,
                fail: false,

            }
        },
        methods: {
            loadWithdrawRequests: function () {
                // Show the loading
                this.tableLoading = true;

                // Clear previous status flags
                //this.success = false;
                this.fail = false;

                // Make the request to the server
                axios.get('/api/admin/withdraw-requests/pending')
                    .then(response => {
                        this.withdrawRequests = response.data;
                    })
                    .catch(error => {
                        if (error.response) {
                            // The request was made and the server responded with a status code
                            // that falls out of the range of 2xx
                            console.log(error.response.status);

                            // Handle validation errors
                            if (error.response.status === 401) {
                                this.fail = {
                                    'message': 'Unauthorized'
                                };
                            } else {
                                this.fail = {
                                    message: 'Something Went Wrong. Check your connection and try again.'
                                };
                            }

                        } else if (error.request) {
                            // The request was made, but no response was received
                            console.log(error.request);

                            this.fail = {
                                message: 'Something Went Wrong. Check your connection and try again.'
                            };

                        } else {
                            // Something happened in setting up the request that triggered an error
                            console.log('Error', error.message);

                            this.fail = {
                                message: 'Something Went Wrong. Check your connection and try again.'
                            };
                        }
                    })
                    .then(e => {
                        // Hide the loading
                        this.tableLoading = false;
                    });
            },
            processWithdrawRequest: function (id, type) {
                // Show the table loading
                this.tableLoading = true;

                // Clear Previous status flags
                this.success = null;
                this.fail = null;

                // Make a request to the server
                axios.post('/api/admin/withdraw-requests/' + id + '/' + type)
                    .then(response => {
                        this.success = {
                            'message' : response.data.message
                        };

                        this.loadWithdrawRequests();
                    })
                    .catch(error => {
                        if (error.response) {
                            // The request was made and the server responded with a status code
                            // that falls out of the range of 2xx
                            console.log(error.response.status);

                            // Handle validation errors
                            if (error.response.status === 401) {
                                this.fail = {
                                    'message': 'Unauthorized'
                                };
                            } else if (error.response.status === 420) {
                                this.fail = {
                                    'message': error.response.data.message
                                };
                            } else {
                                this.fail = {
                                    message: 'Something Went Wrong. Check your connection and try again.'
                                };
                            }

                        } else if (error.request) {
                            // The request was made, but no response was received
                            console.log(error.request);

                            this.fail = {
                                message: 'Something Went Wrong. Check your connection and try again.'
                            };

                        } else {
                            // Something happened in setting up the request that triggered an error
                            console.log('Error', error.message);

                            this.fail = {
                                message: 'Something Went Wrong. Check your connection and try again.'
                            };
                        }
                    })
                    .then(e => {
                        // Hide the loading
                        this.tableLoading = false;
                    });
            }

        },
        mounted() {
            console.log('Admin - Withdraw Requests mounted.');

            // Load Pending Withdraw Requests
            this.loadWithdrawRequests();
        }
    }
</script>
